## dtkmultimedia 1.0.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set (VERSION "1.0.0" CACHE STRING "define project version")

set(BIN_NAME dtkmultimedia)

project(${BIN_NAME}
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtk-template
    DESCRIPTION "dtk library template"
    VERSION ${VERSION}
)

# specify install dir
include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -fno-omit-frame-pointer")
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui DBus)

add_subdirectory(src)
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(examples/player)
endif ()


set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif ()

# test
if (BUILD_TESTING)
   add_subdirectory(tests)
endif ()

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(misc/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
# config cmake file
configure_file(misc/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core dbus")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(misc/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${CMAKE_PROJECT_NAME}")
set (DOXYGEN_QCH_FILE "${CMAKE_PROJECT_NAME}.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "DMULTIMEDIA_BEGIN_NAMESPACE=namespace Dtk { namespace Multimedia {"
    "DMULTIMEDIA_END_NAMESPACE=}}"
    "DMULTIMEDIA_USE_NAMESPACE=using namespace Dtk::Multimedia;"
)

doxygen_add_docs (doxygen
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/dtkmultimedia
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/dtkmultimediawidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/../docs
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/html/${CMAKE_PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== src/CMakeLists.txt ===
add_subdirectory(multimedia)
add_subdirectory(multimediawidgets)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ut-dtkmultimedia)

#add_definitions(-DUSE_MOCK_INTERFACE)

# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-access-control -fno-inline -Wno-pmf-conversions")

include(./dbus/fakeInterface.cmake)

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "../src/multimediawidgets/*.h"
    "../src/multimediawidgets/*.cpp"
    "${INCLUDE_FILES}"
)
file(GLOB_RECURSE TEST_FILES "./*.h" "./*.cpp")

include_directories(
    "../include/dtkmultimedia"
    "../include/dtkmultimediawidgets"
    "../src/multimediawidgets/dbus"
    "3rdparty/cpp-stub"
    "3rdparty/stub-ext"
)

include_directories(../src/multimediawidgets/common/utils)
include_directories(../src/multimediawidgets/engine/interface)
include_directories(../src/multimediawidgets/engine/multimedia)
include_directories(../src/multimediawidgets/engine/multimedia/player)
include_directories(../src/multimediawidgets/engine/plugin/ffmpeg)
include_directories(../src/multimediawidgets/engine/plugin/gstreamer)

add_executable(${BIN_NAME}
    ${INCLUDE_FILES}
    ${SRCS}
    ${TEST_FILES}
    ${DFAKE_INTERFACE_DBUS_XML}
)

find_package(Qt5Widgets)
find_package(Qt5DBus)
find_package(Qt5X11Extras)
find_package(Qt5LinguistTools)
find_package(Qt5Network)
find_package(Qt5Concurrent)
find_package(Qt5Multimedia)
find_package(Qt5MultimediaWidgets)
find_package(PkgConfig REQUIRED)

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)

set(TARGET_LIBS Xtst Qt5::Widgets Qt5::Network Qt5::DBus Qt5::Multimedia Qt5::X11Extras
    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::DBusextended PkgConfig::Gst GL
    Qt5::Concurrent dtkmultimedia)

list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    ${RSVG2_INCLUDE_DIRS}
    ${PROJECT_INCLUDE}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    ${RSVG2_LIBRARIES}
    ${TARGET_LIBS}
    -lpthread
    -lgcov
    -lgtest
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

enable_testing()
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== examples/player/CMakeLists.txt ===
# Generated from player.pro.
# 1.cmake verson，指定cmake版本
cmake_minimum_required(VERSION 3.13)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
# 2.project name
PROJECT(player)


find_package(Qt5Widgets)
find_package(Qt5Network)
find_package(Qt5MultimediaWidgets)

# 4.source directory
AUX_SOURCE_DIRECTORY(. DIR_SRCS)

# 5.set environment variable
SET(SRC_PATH ${DIR_SRCS})

# 6.add executable file
file(GLOB_RECURSE INCLUDE_FILES "../../include/*.h")
ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})


target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimediawidgets
    ${PROJECT_SOURCE_DIR})

set(TARGET_LIBS Qt5::Widgets Qt5::Network   Qt5::MultimediaWidgets)

# 7.add link library
TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia dtkmultimediawidgets)

=== src/multimedia/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ${CMAKE_PROJECT_NAME})

file(GLOB_RECURSE INSTALL_INCLUDE_FILES "../../include/${BIN_NAME}/*")
file(GLOB_RECURSE INCLUDE_FILES "./*.h" "${INSTALL_INCLUDE_FILES}")
file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)
include_directories(../../include/${BIN_NAME})


add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
)

include_directories(ffmpeg)
include_directories(gstreamer)
include_directories(common/algorithm)
include_directories(common/interface)
include_directories(common/utils)

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

find_package(Qt5Gui)
find_package(Qt5X11Extras)
find_package(Qt5Multimedia)


set(TARGET_LIBS Qt5::X11Extras Qt5::Multimedia Qt5::Gui)

list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    ${RSVG2_INCLUDE_DIRS}
    ${PROJECT_INCLUDE}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    ${TARGET_LIBS}
    ${RSVG2_LIBRARIES}
)

install(FILES ${INSTALL_INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
dtkmultimedia (1.0.0) unstable; urgency=medium

  * Initial release

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 01 Jul 2022 14:29:07 +0800

=== debian/control ===
Source: dtkmultimedia
Section: libdevel
Priority: optional
Maintainer: Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 librsvg2-dev,
 qtbase5-dev, pkg-config, qhelpgenerator-qt5 |qttools5-dev-tools, doxygen,
                qtmultimedia5-dev, qttools5-dev,
                libqt5x11extras5-dev, libdtkcore5-bin, libdtkwidget-dev,
                libmpv-dev, libffmpegthumbnailer-dev,libxtst-dev,
                libavcodec-dev, libavformat-dev,libavutil-dev,
                libpulse-dev, libdvdnav-dev, libdbusextended-qt5-dev,
                libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev
Standards-Version: 4.5.0

Package: libdtkmultimedia
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Development Tool Kit multimedia library
 libdtkmultimedia is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkmultimediawidgets
Architecture: any
Depends: ${misc:Depends}, libdtkmultimedia( =${binary:Version})
Description: Development Tool Kit multimediawidgets library
 libdtkmultimediawidgets is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkmultimedia-dev
Architecture: any
Depends:${misc:Depends}, libdtkmultimedia( =${binary:Version}), libdtkmultimediawidgets( =${binary:Version})
Description: Development Tool Kit multimedia devel library
 libdtkmultimedia-dev is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries.

## dtkmultimedia 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,12 @@
 add_subdirectory(src)
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
     add_subdirectory(examples/player)
+    add_subdirectory(examples/audioRecorder)
+    add_subdirectory(examples/camera)
+    add_subdirectory(examples/screenRecorder)
+    add_subdirectory(examples/screenShot)
+    add_subdirectory(examples/ocrCmd)
+    add_subdirectory(examples/ocrDebugger)
 endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,8 @@
 file(GLOB_RECURSE SRCS
     "../src/multimediawidgets/*.h"
     "../src/multimediawidgets/*.cpp"
+    "../src/ocr/*.h"
+    "../src/ocr/*.cpp"
     "${INCLUDE_FILES}"
 )
 file(GLOB_RECURSE TEST_FILES "./*.h" "./*.cpp")
@@ -21,6 +23,7 @@
 include_directories(
     "../include/dtkmultimedia"
     "../include/dtkmultimediawidgets"
+    "../include/dtkocr"
     "../src/multimediawidgets/dbus"
     "3rdparty/cpp-stub"
     "3rdparty/stub-ext"
@@ -32,6 +35,7 @@
 include_directories(../src/multimediawidgets/engine/multimedia/player)
 include_directories(../src/multimediawidgets/engine/plugin/ffmpeg)
 include_directories(../src/multimediawidgets/engine/plugin/gstreamer)
+include_directories(../src/ocr/ppocr)
 
 add_executable(${BIN_NAME}
     ${INCLUDE_FILES}
@@ -50,14 +54,21 @@
 find_package(Qt5MultimediaWidgets)
 find_package(PkgConfig REQUIRED)
 
+find_package(OpenMP)
+if(OPENMP_FOUND)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fopenmp")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
+endif()
+
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
 pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
 pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)
+pkg_check_modules(InferenceEngine REQUIRED ncnn opencv_mobile)
 
 set(TARGET_LIBS Xtst Qt5::Widgets Qt5::Network Qt5::DBus Qt5::Multimedia Qt5::X11Extras
-    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::DBusextended PkgConfig::Gst GL
-    Qt5::Concurrent dtkmultimedia)
+    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::DBusextended PkgConfig::Gst GL dl
+    Qt5::Concurrent dtkmultimedia dtkocr)
 
 list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
 
@@ -66,6 +77,7 @@
     Qt${QT_VERSION_MAJOR}::Gui
     Qt${QT_VERSION_MAJOR}::DBus
     ${RSVG2_INCLUDE_DIRS}
+    ${InferenceEngine_INCLUDE_DIRS}
     ${PROJECT_INCLUDE}
 )
 
@@ -74,6 +86,7 @@
     Qt${QT_VERSION_MAJOR}::Gui
     Qt${QT_VERSION_MAJOR}::DBus
     ${RSVG2_LIBRARIES}
+    ${InferenceEngine_LIBRARIES}
     ${TARGET_LIBS}
     -lpthread
     -lgcov
@@ -87,5 +100,8 @@
     target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
 endif()
 
+set(ModelSaveSubDir dtkocrmodels)
+ADD_DEFINITIONS(-DOCR_MODEL_DIR="${CMAKE_CURRENT_LIST_DIR}/../src/ocr/${ModelSaveSubDir}/")
+
 enable_testing()
 add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== examples/audioRecorder/CMakeLists.txt ===
# Generated from audioRecorder.pro.
# 1.cmake verson，指定cmake版本
cmake_minimum_required(VERSION 3.13)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
# 2.project name
PROJECT(audioRecorder)


find_package(Qt5Widgets)
find_package(Qt5Network)
find_package(Qt5MultimediaWidgets)

# 4.source directory
AUX_SOURCE_DIRECTORY(. DIR_SRCS)

# 5.set environment variable
SET(SRC_PATH ${DIR_SRCS})

# 6.add executable file
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkmultimedia/*.h")
ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})


target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
    ${PROJECT_SOURCE_DIR})

set(TARGET_LIBS  Qt5::Network Qt5::MultimediaWidgets)

# 7.add link library
TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia)

=== examples/camera/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
# 2.project name
PROJECT(camera CXX C)


find_package(Qt5Widgets)
find_package(Qt5Network)
find_package(Qt5MultimediaWidgets)

# 4.source directory
AUX_SOURCE_DIRECTORY(. DIR_SRCS)

# 5.set environment variable
SET(SRC_PATH ${DIR_SRCS})

QT5_WRAP_UI (project_FORMS_HEADERS **.ui)

# 6.add executable file
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkmultimedia/*.h")
ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})


target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
    ${PROJECT_SOURCE_DIR})

set(TARGET_LIBS Qt5::Widgets Qt5::Network Qt5::Multimedia  Qt5::MultimediaWidgets)

# 7.add link library
TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia)

=== examples/ocrCmd/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.10)
project(ocrcmd)

#for Qt
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(QtModule Core Gui)
find_package(Qt5 REQUIRED ${QtModule})

include_directories(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
)
add_definitions(${QT_DEFINITIONS})

include(CMakePackageConfigHelpers)

#for project files
include_directories(.)
aux_source_directory(. allSource)

#for dtkocr
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkocr/*.h")

add_executable(${PROJECT_NAME} ${allSource})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkocr
    ${PROJECT_SOURCE_DIR})

target_link_libraries(${PROJECT_NAME} dtkocr Qt5::Core Qt5::Gui)

=== examples/ocrDebugger/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.10)
project(ocrdebugger)

#for Qt
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(QtModule Core Gui Widgets)
find_package(Qt5 REQUIRED ${QtModule})

include_directories(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
)
add_definitions(${QT_DEFINITIONS})

include(CMakePackageConfigHelpers)

#for project files
include_directories(.)
aux_source_directory(. allSource)

#for dtkocr
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkocr/*.h")

add_executable(${PROJECT_NAME} ${allSource})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkocr
    ${PROJECT_SOURCE_DIR})

target_link_libraries(${PROJECT_NAME} dtkocr Qt5::Core Qt5::Gui Qt5::Widgets)

=== examples/player/CMakeLists.txt ===
--- 
+++ 
@@ -24,14 +24,13 @@
 file(GLOB_RECURSE INCLUDE_FILES "../../include/*.h")
 ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})
 
-
 target_include_directories(${PROJECT_NAME} PUBLIC
     ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
     ${PROJECT_SOURCE_DIR}/../../include/dtkmultimediawidgets
-    ${PROJECT_SOURCE_DIR})
+    ${PROJECT_SOURCE_DIR}/../../include/dtkocr)
 
-set(TARGET_LIBS Qt5::Widgets Qt5::Network   Qt5::MultimediaWidgets)
+set(TARGET_LIBS Qt5::Widgets Qt5::Network Qt5::MultimediaWidgets)
 
 # 7.add link library
-TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia dtkmultimediawidgets)
+TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia dtkmultimediawidgets dtkocr)

=== examples/screenRecorder/CMakeLists.txt ===
# Generated from audioRecorder.pro.
# 1.cmake verson，指定cmake版本
cmake_minimum_required(VERSION 3.13)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
# 2.project name
PROJECT(screenRecorder)


find_package(Qt5Widgets)
find_package(Qt5Network)
find_package(Qt5MultimediaWidgets)

# 4.source directory
AUX_SOURCE_DIRECTORY(. DIR_SRCS)

# 5.set environment variable
SET(SRC_PATH ${DIR_SRCS})

# 6.add executable file
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkmultimedia/*.h")
ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})


target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
    ${PROJECT_SOURCE_DIR})

set(TARGET_LIBS  Qt5::Network Qt5::MultimediaWidgets)

# 7.add link library
TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia)

=== examples/screenShot/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.13)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
# 2.project name
PROJECT(screenShot)


find_package(Qt5Widgets)
find_package(Qt5Network)
find_package(Qt5MultimediaWidgets)

# 4.source directory
AUX_SOURCE_DIRECTORY(. DIR_SRCS)

# 5.set environment variable
SET(SRC_PATH ${DIR_SRCS})

# 6.add executable file
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkmultimedia/*.h" "../../include/dtkmultimediawidgets/*.h")
ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})


target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimediawidgets
    ${PROJECT_SOURCE_DIR})

set(TARGET_LIBS Qt5::Multimedia Qt5::MultimediaWidgets)

# 7.add link library
TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia dtkmultimediawidgets)

=== src/multimedia/CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,13 @@
 # SPDX-License-Identifier: LGPL-3.0-or-later
 
 set(BIN_NAME ${CMAKE_PROJECT_NAME})
+project(${BIN_NAME} CXX C)
 
 file(GLOB_RECURSE INSTALL_INCLUDE_FILES "../../include/${BIN_NAME}/*")
 file(GLOB_RECURSE INCLUDE_FILES "./*.h" "${INSTALL_INCLUDE_FILES}")
 file(GLOB_RECURSE SRCS
     "./*.h"
+    "./*.c"
     "./*.cpp"
 )
 include_directories(../../include/${BIN_NAME})
@@ -23,6 +25,12 @@
 include_directories(common/algorithm)
 include_directories(common/interface)
 include_directories(common/utils)
+include_directories(camera/libcam/libcam_v4l2core)
+include_directories(camera/libcam/libcam_render)
+include_directories(camera/libcam/libcam_encoder)
+include_directories(camera/libcam/libcam_audio)
+include_directories(camera/libcam/libcam)
+include_directories(camera/libcam)
 
 set_target_properties(${BIN_NAME} PROPERTIES
     VERSION ${CMAKE_PROJECT_VERSION}
@@ -37,7 +45,7 @@
 
 set(TARGET_LIBS Qt5::X11Extras Qt5::Multimedia Qt5::Gui)
 
-list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
+list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0 /usr/include/libusb-1.0)
 
 target_include_directories(${BIN_NAME} PUBLIC
     Qt${QT_VERSION_MAJOR}::Core

=== src/multimediawidgets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ${CMAKE_PROJECT_NAME}widgets)

file(GLOB_RECURSE INSTALL_INCLUDE_FILES "../../include/${BIN_NAME}/*")
file(GLOB_RECURSE INCLUDE_FILES "./*.h"  "${INSTALL_INCLUDE_FILES}")
file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
)

include_directories(../../include)
include_directories(../../include/dtkmultimediawidgets)
include_directories(../../include/dtkmultimedia)
include_directories(common/utils)
include_directories(engine/interface)
include_directories(engine/multimedia)
include_directories(engine/multimedia/player)
include_directories(engine/plugin/ffmpeg)
include_directories(engine/plugin/gstreamer)

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

find_package(Qt5Widgets)
find_package(Qt5DBus)
find_package(Qt5X11Extras)
find_package(Qt5LinguistTools)
find_package(Qt5Network)
find_package(Qt5Concurrent)
find_package(Qt5Multimedia)
find_package(Qt5MultimediaWidgets)
find_package(PkgConfig REQUIRED)

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)

set(TARGET_LIBS Xtst Qt5::Widgets Qt5::Network Qt5::DBus Qt5::Multimedia Qt5::X11Extras
    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::DBusextended PkgConfig::Gst GL
    Qt5::Concurrent dtkmultimedia)

list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    ${RSVG2_INCLUDE_DIRS}
    ${PROJECT_INCLUDE}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    ${TARGET_LIBS}
    ${RSVG2_LIBRARIES}
)

install(FILES ${INSTALL_INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/ocr/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME dtkocr)

file(GLOB_RECURSE INSTALL_INCLUDE_FILES "../../include/${BIN_NAME}/*")
file(GLOB_RECURSE INCLUDE_FILES "./*.h" "${INSTALL_INCLUDE_FILES}")
file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)
include_directories(../../include/${BIN_NAME})

find_package(Qt5Gui)
find_package(PkgConfig REQUIRED)

set(TARGET_LIBS Qt5::Gui)

add_library(${BIN_NAME} SHARED
    ${INSTALL_INCLUDE_FILES}
    ${INCLUDE_FILES}
    ${SRCS}
)

include_directories(interface)
include_directories(ppocr)

pkg_check_modules(InferenceEngine REQUIRED ncnn opencv_mobile)
find_package(OpenMP)
if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fopenmp")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
endif()

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    ${PROJECT_INCLUDE}
    ${InferenceEngine_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    ${TARGET_LIBS}
    ${InferenceEngine_LIBRARIES}
)

install(FILES ${INSTALL_INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(PROJECT_ROOT_DIR ${CMAKE_CURRENT_LIST_DIR}/../..)

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)
# config pkgconfig file
configure_file(${PROJECT_ROOT_DIR}/misc/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
# config cmake file
configure_file(${PROJECT_ROOT_DIR}/misc/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(${PROJECT_ROOT_DIR}/misc/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

# config the deep learning models of the default plugin
set(SourcesDir ${CMAKE_INSTALL_PREFIX}/share)
set(CurrentProjectSourcesDir lib${BIN_NAME})
set(ModelSaveSubDir dtkocrmodels)
set(ModelInstallDir ${SourcesDir}/${CurrentProjectSourcesDir})

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    ADD_DEFINITIONS(-DOCR_MODEL_DIR="${CMAKE_CURRENT_LIST_DIR}/${ModelSaveSubDir}/")
else()
    ADD_DEFINITIONS(-DOCR_MODEL_DIR="${CurrentProjectSourcesDir}/${ModelSaveSubDir}/")
endif()

install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/${ModelSaveSubDir} DESTINATION ${ModelInstallDir})

=== debian/changelog ===
dtkmultimedia (1.0.2-1) unstable; urgency=medium

  * update

 -- Packages Builder <packages@deepin.com>  Wed, 04 Jan 2023 14:04:57 +0800

dtkmultimedia (1.0.2) unstable; urgency=medium

  * add ocr feature
  * update version

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 04 Jan 2023 13:10:07 +0800

dtkmultimedia (1.0.1) unstable; urgency=medium

  * update version

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 14 Dec 2022 13:29:07 +0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,9 @@
                 libmpv-dev, libffmpegthumbnailer-dev,libxtst-dev,
                 libavcodec-dev, libavformat-dev,libavutil-dev,
                 libpulse-dev, libdvdnav-dev, libdbusextended-qt5-dev,
-                libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev
+                libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev,
+		libavdevice-dev, libswscale-dev, libswresample-dev, libavfilter-dev, libudev-dev, libusb-1.0-0-dev, portaudio19-dev, libv4l-dev,
+                libncnn-dev, libopencv-mobile-dev
 Standards-Version: 4.5.0
 
 Package: libdtkmultimedia
@@ -33,8 +35,24 @@
 
 Package: libdtkmultimedia-dev
 Architecture: any
-Depends:${misc:Depends}, libdtkmultimedia( =${binary:Version}), libdtkmultimediawidgets( =${binary:Version})
+Depends: ${misc:Depends}, libdtkmultimedia( =${binary:Version}), libdtkmultimediawidgets( =${binary:Version})
 Description: Development Tool Kit multimedia devel library
  libdtkmultimedia-dev is base devel library of Deepin Qt/C++ applications.
  .
  This package contains the header files and static libraries.
+
+Package: libdtkocr
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Development Tool Kit ocr library
+ libdtkocr is base library of Deepin Qt/C++ applications.
+ .
+ This package contains the shared libraries.
+
+Package: libdtkocr-dev
+Architecture: any
+Depends: ${misc:Depends}, libdtkocr( =${binary:Version})
+Description: Development Tool Kit ocr devel library
+ libdtkocr-dev is base devel library of Deepin Qt/C++ applications.
+ .
+ This package contains the header files and static libraries.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5
VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_VERSION=$(BUILD_VER) -DVERSION=$(PACK_VER)

## dtkmultimedia 1.0.6

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -11,28 +11,50 @@
 set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
 set (DOXYGEN_EXTRACT_STATIC YES)
 set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
-set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
 set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
-set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${CMAKE_PROJECT_NAME}")
-set (DOXYGEN_QCH_FILE "${CMAKE_PROJECT_NAME}.qch")
-set (DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
 set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
 set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
 set (DOXYGEN_MACRO_EXPANSION "YES")
 set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
+
+#Multimedia
+set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/${CMAKE_PROJECT_NAME})
+set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${CMAKE_PROJECT_NAME}")
+set (DOXYGEN_QCH_FILE "${CMAKE_PROJECT_NAME}.qch")
+set (DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
 set (DOXYGEN_PREDEFINED
     "DMULTIMEDIA_BEGIN_NAMESPACE=namespace Dtk { namespace Multimedia {"
     "DMULTIMEDIA_END_NAMESPACE=}}"
     "DMULTIMEDIA_USE_NAMESPACE=using namespace Dtk::Multimedia;"
 )
-
-doxygen_add_docs (doxygen
+doxygen_add_docs (doxygen_Multimedia
     ${CMAKE_CURRENT_SOURCE_DIR}/../include/dtkmultimedia
     ${CMAKE_CURRENT_SOURCE_DIR}/../include/dtkmultimediawidgets
-    ${CMAKE_CURRENT_SOURCE_DIR}/../docs
+    ${CMAKE_CURRENT_SOURCE_DIR}/../docs/dtkmultimedia
+    ${CMAKE_CURRENT_SOURCE_DIR}/../docs/dtkmultimediawidgets
     ALL
     WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
     COMMENT "Generate documentation via Doxygen"
 )
 
-install (FILES ${CMAKE_CURRENT_BINARY_DIR}/html/${CMAKE_PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})
+#OCR
+set (OCR_BIN_NAME dtkocr)
+set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/${OCR_BIN_NAME})
+set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${OCR_BIN_NAME}")
+set (DOXYGEN_QCH_FILE "${OCR_BIN_NAME}.qch")
+set (DOXYGEN_QHP_VIRTUAL_FOLDER ${OCR_BIN_NAME})
+set (DOXYGEN_PREDEFINED
+    "DOCR_BEGIN_NAMESPACE=namespace Dtk { namespace Ocr {"
+    "DOCR_END_NAMESPACE=}}"
+    "DOCR_USE_NAMESPACE=using namespace DOCR_NAMESPACE;"
+)
+doxygen_add_docs (doxygen_OCR
+    ${CMAKE_CURRENT_SOURCE_DIR}/../include/dtkocr
+    ${CMAKE_CURRENT_SOURCE_DIR}/../docs/dtkocr
+    ALL
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
+    COMMENT "Generate documentation via Doxygen"
+)
+
+install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}/html/${CMAKE_PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})
+install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${OCR_BIN_NAME}/html/${OCR_BIN_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/audioRecorder/CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,8 @@
 # 2.project name
 PROJECT(audioRecorder)
 
-
-find_package(Qt5Widgets)
-find_package(Qt5Network)
-find_package(Qt5MultimediaWidgets)
+find_package(Qt${QT_VERSION_MAJOR}Network)
+find_package(Qt${QT_VERSION_MAJOR}MultimediaWidgets)
 
 # 4.source directory
 AUX_SOURCE_DIRECTORY(. DIR_SRCS)
@@ -29,8 +27,10 @@
     ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
     ${PROJECT_SOURCE_DIR})
 
-set(TARGET_LIBS  Qt5::Network Qt5::MultimediaWidgets)
+set(TARGET_LIBS
+    Qt${QT_VERSION_MAJOR}::Network
+    Qt${QT_VERSION_MAJOR}::MultimediaWidgets)
 
 # 7.add link library
-TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia)
+TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${TARGET_LIBS} dtkmultimedia)

=== examples/camera/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
# 2.project name
PROJECT(camera CXX C)

find_package(Qt${QT_VERSION_MAJOR}Widgets)
find_package(Qt${QT_VERSION_MAJOR}Network)
find_package(Qt${QT_VERSION_MAJOR}MultimediaWidgets)
if (ENABLE_Qt6)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS OpenGLWidgets)
endif()

# 4.source directory
AUX_SOURCE_DIRECTORY(. DIR_SRCS)

# 5.set environment variable
SET(SRC_PATH ${DIR_SRCS})

if (ENABLE_Qt6)
    QT6_WRAP_UI (project_FORMS_HEADERS camera_qt6.ui)
    set(UI_FILES camera_qt6.ui)
else()
    QT5_WRAP_UI (project_FORMS_HEADERS camera_qt5.ui)
    set(UI_FILES camera_qt5.ui)
endif()

# 6.add executable file
file(GLOB_RECURSE INCLUDE_FILES "../../include/dtkmultimedia/*.h")
ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES} ${UI_FILES})


target_include_directories(${PROJECT_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
    ${PROJECT_SOURCE_DIR})

set(TARGET_LIBS
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Multimedia
    Qt${QT_VERSION_MAJOR}::MultimediaWidgets
    )


# 7.add link library
TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia)

if (ENABLE_Qt6)
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} Qt${QT_VERSION_MAJOR}::OpenGLWidgets)
endif()

=== examples/ocrCmd/CMakeLists.txt ===
--- 
+++ 
@@ -12,12 +12,13 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_AUTOUIC ON)
+
 set(QtModule Core Gui)
-find_package(Qt5 REQUIRED ${QtModule})
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED ${QtModule})
 
 include_directories(
-    ${Qt5Core_INCLUDE_DIRS}
-    ${Qt5Gui_INCLUDE_DIRS}
+    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
+    ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS}
 )
 add_definitions(${QT_DEFINITIONS})
 
@@ -36,4 +37,4 @@
     ${PROJECT_SOURCE_DIR}/../../include/dtkocr
     ${PROJECT_SOURCE_DIR})
 
-target_link_libraries(${PROJECT_NAME} dtkocr Qt5::Core Qt5::Gui)
+target_link_libraries(${PROJECT_NAME} dtkocr Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Gui)

=== examples/ocrDebugger/CMakeLists.txt ===
--- 
+++ 
@@ -12,13 +12,14 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_AUTOUIC ON)
+
 set(QtModule Core Gui Widgets)
-find_package(Qt5 REQUIRED ${QtModule})
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED ${QtModule})
 
 include_directories(
-    ${Qt5Core_INCLUDE_DIRS}
-    ${Qt5Gui_INCLUDE_DIRS}
-    ${Qt5Widgets_INCLUDE_DIRS}
+    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
+    ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS}
+    ${Qt${QT_VERSION_MAJOR}Widgets_INCLUDE_DIRS}
 )
 add_definitions(${QT_DEFINITIONS})
 
@@ -37,4 +38,7 @@
     ${PROJECT_SOURCE_DIR}/../../include/dtkocr
     ${PROJECT_SOURCE_DIR})
 
-target_link_libraries(${PROJECT_NAME} dtkocr Qt5::Core Qt5::Gui Qt5::Widgets)
+target_link_libraries(${PROJECT_NAME} dtkocr
+    Qt${QT_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::Gui
+    Qt${QT_VERSION_MAJOR}::Widgets)

=== examples/ocrPlugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.10)
project(dtkocrpluginexample)
set(BIN_NAME load)

#for Qt
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(QtModule Core Gui)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED ${QtModule})

include_directories(
    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS}
)
add_definitions(${QT_DEFINITIONS})

include(CMakePackageConfigHelpers)

#for project files
include_directories(.)
aux_source_directory(. allSource)

#for ocr plugin manager
find_package(dtkocr)
include_directories(${dtkocr_INCLUDE_DIRS})

#link
add_library(${BIN_NAME} SHARED ${allSource})
target_link_libraries(${BIN_NAME} Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Gui)

#install
include(GNUInstallDirs)

#.so file
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/libdtkocr/plugins/${PROJECT_NAME})

#model file
set(SourcesDir ${CMAKE_INSTALL_PREFIX}/share)
set(CurrentProjectSourcesDir libdtkocr)
set(ModelSaveSubDir dtkocrpluginexamplemodel)
set(ModelInstallDir ${SourcesDir}/${CurrentProjectSourcesDir})
ADD_DEFINITIONS(-DOCR_MODEL_DIR="${CurrentProjectSourcesDir}/${ModelSaveSubDir}/")
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/${ModelSaveSubDir} DESTINATION ${ModelInstallDir})

=== examples/player/CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,9 @@
 # 2.project name
 PROJECT(player)
 
-
-find_package(Qt5Widgets)
-find_package(Qt5Network)
-find_package(Qt5MultimediaWidgets)
+find_package(Qt${QT_VERSION_MAJOR}Widgets)
+find_package(Qt${QT_VERSION_MAJOR}Network)
+find_package(Qt${QT_VERSION_MAJOR}MultimediaWidgets)
 
 # 4.source directory
 AUX_SOURCE_DIRECTORY(. DIR_SRCS)
@@ -22,6 +21,11 @@
 
 # 6.add executable file
 file(GLOB_RECURSE INCLUDE_FILES "../../include/*.h")
+if (ENABLE_Qt6)
+file(GLOB_RECURSE SRC_FILES ${PROJECT_SOURCE_DIR}/qt6player/*.cpp)
+include_directories(${PROJECT_SOURCE_DIR}/qt6player/*.h)
+list(APPEND SRC_PATH ${SRC_FILES})
+endif()
 ADD_EXECUTABLE(${PROJECT_NAME} ${SRC_PATH} ${INCLUDE_FILES})
 
 target_include_directories(${PROJECT_NAME} PUBLIC
@@ -29,7 +33,7 @@
     ${PROJECT_SOURCE_DIR}/../../include/dtkmultimediawidgets
     ${PROJECT_SOURCE_DIR}/../../include/dtkocr)
 
-set(TARGET_LIBS Qt5::Widgets Qt5::Network Qt5::MultimediaWidgets)
+set(TARGET_LIBS Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::MultimediaWidgets)
 
 # 7.add link library
 TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia dtkmultimediawidgets dtkocr)

=== examples/screenRecorder/CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,9 @@
 # 2.project name
 PROJECT(screenRecorder)
 
-
-find_package(Qt5Widgets)
-find_package(Qt5Network)
-find_package(Qt5MultimediaWidgets)
+find_package(Qt${QT_VERSION_MAJOR}Widgets)
+find_package(Qt${QT_VERSION_MAJOR}Network)
+find_package(Qt${QT_VERSION_MAJOR}MultimediaWidgets)
 
 # 4.source directory
 AUX_SOURCE_DIRECTORY(. DIR_SRCS)
@@ -29,7 +28,11 @@
     ${PROJECT_SOURCE_DIR}/../../include/dtkmultimedia
     ${PROJECT_SOURCE_DIR})
 
-set(TARGET_LIBS  Qt5::Network Qt5::MultimediaWidgets)
+set(TARGET_LIBS
+    Qt${QT_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::Gui
+    Qt${QT_VERSION_MAJOR}::Network
+    Qt${QT_VERSION_MAJOR}::MultimediaWidgets)
 
 # 7.add link library
 TARGET_LINK_LIBRARIES(${PROJECT_NAME}  ${TARGET_LIBS} dtkmultimedia)

=== src/multimediawidgets/CMakeLists.txt ===
--- 
+++ 
@@ -32,24 +32,39 @@
 
 target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")
 
-find_package(Qt5Widgets)
-find_package(Qt5DBus)
-find_package(Qt5X11Extras)
-find_package(Qt5LinguistTools)
-find_package(Qt5Network)
-find_package(Qt5Concurrent)
-find_package(Qt5Multimedia)
-find_package(Qt5MultimediaWidgets)
+find_package(Qt${QT_VERSION_MAJOR}Widgets)
+find_package(Qt${QT_VERSION_MAJOR}DBus)
+find_package(Qt${QT_VERSION_MAJOR}LinguistTools)
+find_package(Qt${QT_VERSION_MAJOR}Network)
+find_package(Qt${QT_VERSION_MAJOR}Concurrent)
+find_package(Qt${QT_VERSION_MAJOR}Multimedia)
+find_package(Qt${QT_VERSION_MAJOR}MultimediaWidgets)
+find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core)
+find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget)
+if (ENABLE_Qt6)
+    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS OpenGLWidgets)
+else()
+    find_package(Qt5X11Extras)
+endif()
+
 find_package(PkgConfig REQUIRED)
 
-pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
-pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
-pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
+if (NOT ENABLE_Qt6)
+    pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
+endif()
+
 pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)
 
-set(TARGET_LIBS Xtst Qt5::Widgets Qt5::Network Qt5::DBus Qt5::Multimedia Qt5::X11Extras
-    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::DBusextended PkgConfig::Gst GL
-    Qt5::Concurrent dtkmultimedia)
+
+set(TARGET_LIBS Xtst
+    Qt${QT_VERSION_MAJOR}::Widgets
+    Qt${QT_VERSION_MAJOR}::Network
+    Qt${QT_VERSION_MAJOR}::DBus
+    Qt${QT_VERSION_MAJOR}::Multimedia
+    Qt${QT_VERSION_MAJOR}::MultimediaWidgets
+    Qt${QT_VERSION_MAJOR}::Concurrent
+    PkgConfig::Gst GL
+    dtkmultimedia)
 
 list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
 
@@ -59,15 +74,29 @@
     Qt${QT_VERSION_MAJOR}::DBus
     ${RSVG2_INCLUDE_DIRS}
     ${PROJECT_INCLUDE}
-)
+    )
 
 target_link_libraries(${BIN_NAME} PRIVATE
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::Gui
     Qt${QT_VERSION_MAJOR}::DBus
+    Dtk${DTK_VERSION_MAJOR}::Core
+    Dtk${DTK_VERSION_MAJOR}::Widget
     ${TARGET_LIBS}
     ${RSVG2_LIBRARIES}
-)
+    )
+
+if (ENABLE_Qt6)
+    target_link_libraries(${BIN_NAME} PRIVATE
+        Qt${QT_VERSION_MAJOR}::GuiPrivate
+        Qt${QT_VERSION_MAJOR}::OpenGLWidgets
+        )
+else()
+    target_link_libraries(${BIN_NAME} PRIVATE
+        PkgConfig::DBusextended
+        Qt5::X11Extras
+        )
+endif()
 
 install(FILES ${INSTALL_INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
 install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
dtkmultimedia (1.0.6-1) unstable; urgency=medium

  * update

 -- Packages Builder <packages@deepin.com>  Mon, 18 Sep 2023 11:13:29 +0800

dtkmultimedia (1.0.6) unstable; urgency=medium

  * fix memory leak

 -- Deepin Packages Builder <packages@deepin.com>  Thur, 14 Sep 2023 15:33:21 +0800

dtkmultimedia (1.0.5) unstable; urgency=medium

  * fix compile error

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 22 Aug 2023 10:13:45 +0800

dtkmultimedia (1.0.4) unstable; urgency=medium

  * update version

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 08 Mar 2023 10:13:45 +0800

dtkmultimedia (1.0.3) unstable; urgency=medium

  * add multimedia info and convert feature
  * add ocr normal plugin feature
  * update version

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 04 Jan 2023 13:10:07 +0800
